#include "defBlackfin_Core.h"

.global __start;

.extern ldf_stack_end;
.extern _main;
//.extern _sim_terminate_fail;
.extern _sec_unused_error_handler;



#define __SUPERVISOR_MODE__ 1

#define REG_RCU_CN_RES
#define REG_RCU_CN_CTL


/****************************************************************************/
/*                                                                          */
/*  Functions                                                               */
/*                                                                          */
/****************************************************************************/
.section program;

__start:
    nop;
    nop;
    nop;
    nop;
__start_evtinit:    
    r7.l = lo(_sec_unused_error_handler);
    r7.h = hi(_sec_unused_error_handler);

    p4.l = lo(REG_ICU_EVT2);
    p4.h = hi(REG_ICU_EVT2);

    p3 = 14;
    
    /*************************************************/
    /* Initialize interrupt vectors to error handler */
    /*************************************************/
    lsetup(__start.evtinit.loop, __start.evtinit.loop) lc0 = p3;
__start.evtinit.loop: [p4++] = r7;
   


__start.stackinit:
    /************************/
    /* Initialize the stack */
    /************************/
    sp.l = lo(ldf_stack_end);
    sp.h = hi(ldf_stack_end);
    usp = sp;
    fp = sp;
    sp += -12;

__start.mode:


#if defined (__SUPERVISOR_MODE__)
// Setup for CoreA to execute test in Supervisor Mode

/* Set the interrupt vector to __setup.supervisor */
p3.l = lo(__setup.supervisor);
p3.h = hi(__setup.supervisor);
p4.l = lo(REG_ICU_EVT15);
p4.h = hi(REG_ICU_EVT15);
[p4] = p3;

/* Enable interrupt 15 */
p4.l = lo(REG_ICU_IMASK);
p4.h = hi(REG_ICU_IMASK);
r7 = [p4];
bitset(r7, BITP_ICU_IMASK_IVG15);
[p4] = r7;
 
raise 15;                        // Assert interrupt 15

p3.l = lo(__start.wait);
p3.h = hi(__start.wait);
reti = p3;                       // Set return address to __start.wait or _main
nop;nop;nop;nop;
rti;                             // Return from Reset Interrupt

#else
p3.l = lo(_main);
p3.h = hi(_main);
reti = p3;                       // Set return address to __start.wait or _main
rti;                             // Return from Reset Interrupt
#endif

__start.wait: jump __start.wait;     // Wait here till IVG15 interrupt is processed

__setup.supervisor:
[--sp] = reti;  // re-enables the interrupt system
r0 = 0;
[--sp] = r0;
[--sp] = r0;
fp=sp;
sp+=-12;
call _main;
__setup.supervisor.end:
nop;
nop;
nop;
nop;
//call _sim_terminate_fail;
nop;
nop;
nop;
nop;
nop;
nop;
nop;
nop;
__start.end:
